# Markdown Oxide Getting Started Guide

If you want to get started using Markdown-Oxide, you are in the right place!

# Setup 

First, we must integrate Markdown-oxide with your text editor.

Navigate to the setup for your editor using the table-of-contents to the right.

## Installation and Editor Config

### ![[README#Neovim]]

### ![[README#VSCode]]

### ![[README#Zed]]

### ![[README#Helix]]

## Configuration

![[Configuration#^configurationinfo]]

You can probably leave the settings as their defaults for now, but here are a few you may want to set.

- [Daily Note Format](<Configuration#Daily Note Format Config Option>). If you have obsidian, this one is automatically imported if not set.
- Do you *not* use the first heading of your markdown files as the file title? You probably want to disable [[Configuration#Default Config File|title headings]]
- Do you have a specific folder where your daily notes are? Try [Daily Notes Folder](<Configuration#Default Config File>). *This may be imported from Obsidian*
- Do you have a specific folder where new files should be created? Try [[Configuration#Default Config File|New Files Folder]]. *This may be imported from Obsidian*
- Do you want `.md` parsed and appended in your links? [[Configuration#Default Config File|MD Extension]]

# Using markdown-oxide

Now that you are set up, it is time to start using your new PKM! 

Most editors have an LSP interface that makes using Markdown-oxide's features intuitive. Over time, you will figure out a workflow that fits your needs. 

Additionally, you can reference the gifs and descriptions in the [[Features]] to figure out how to use different features. 

I am working toward a future where all of markdown-oxide's features are thoroughly documented, but we are not there yet!

# Future steps

As you use Markdown Oxide more, there may be behavior you want to configure. For this, check the [[Configuration]].

And if you want to have local access to the settings, here is the [default config file](<Configuration#Default Config File>) for you to copy and paste. 

I hope you enjoy! Feel free to open issues for bugs and features on the GitHub repo: https://github.com/Feel-ix-343/markdown-oxide

[^1]: ![[rug/Documentation Notes#^docEmbeds]]